[PATCH] defaultenv-2: init: don't call timeout again if the user intervened
Michael Olbrich
m.olbrich at pengutronix.de
Mon Feb 16 03:23:31 PST 2015
With autoboot_timeout=0 the second 'timeout' might not get another
character even if the user keeps a key pressed. So just reuse the key from
the first call.
Signed-off-by: Michael Olbrich <m.olbrich at pengutronix.de>
---
defaultenv/defaultenv-2-base/bin/init | 7 +++++--
1 file changed, 5 insertions(+), 2 deletions(-)
diff --git a/defaultenv/defaultenv-2-base/bin/init b/defaultenv/defaultenv-2-base/bin/init
index 34807bcf585d..30651e55d277 100644
--- a/defaultenv/defaultenv-2-base/bin/init
+++ b/defaultenv/defaultenv-2-base/bin/init
@@ -37,6 +37,7 @@ fi
# allow to stop the boot before execute the /env/init/*
# but without waiting
timeout -s -a -v key 0
+autoboot="$?"
if [ "${key}" = "q" ]; then
${login_cmd}
@@ -57,8 +58,10 @@ fi
[ -n ${login_cmd} ] && global.console.input_allow=1
-timeout -a $global.autoboot_timeout -v key
-autoboot="$?"
+if [ "$autoboot" = 0 ]; then
+ timeout -a $global.autoboot_timeout -v key
+ autoboot="$?"
+fi
[ -n ${login_cmd} ] && global.console.input_allow=0
--
2.1.4
More information about the barebox
mailing list